#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
# generated by wxGlade 0.6.3 on Sat Jan 12 13:21:10 2008
"""
Esporta in Excel il risultato di una Query SQL, lanciata su un DB definito come DSN ODBC
Ha un'interfaccia GUI scritta in wxPython e generata con l'aiuto di wxGlade

Richiede i componenti :

   PythonWin   (per l'accesso ad ADO)
   wxWindow    (per l'interfaccia GUI)

   oltre al mio modulo ExcelXML

"""

import ExcelXML
import win32com.client
import wx
import wx.grid


# begin wxGlade: extracode
# end wxGlade


class MyQuery(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyQuery.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.TitoloTabella = wx.StaticText(self, -1, "Tabella")
        self.QueryGrid = wx.grid.Grid(self, -1, size=(1, 1))

        self.__set_properties()
        self.__do_layout()
        # end wxGlade
        nRighe = self.QueryGrid.GetNumberRows()
        nCols = self.QueryGrid.GetNumberCols()
        # svuota la grid esistente
        self.QueryGrid.DeleteRows(0,nRighe)
        self.QueryGrid.DeleteCols(0,nCols)
        self.QueryGrid.SetRowLabelSize(50)
        self.NomiCampi = []

    def __set_properties(self):
        # begin wxGlade: MyQuery.__set_properties
        self.SetTitle("Risultato della Query")
        self.SetSize((750, 570))
        self.SetBackgroundColour(wx.Colour(208, 208, 208))
        self.TitoloTabella.SetForegroundColour(wx.Colour(255, 0, 0))
        self.TitoloTabella.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.QueryGrid.CreateGrid(1, 2)
        self.QueryGrid.EnableEditing(0)
        self.QueryGrid.SetMinSize((713, 494))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyQuery.__do_layout
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7.Add(self.TitoloTabella, 0, wx.ALL|wx.EXPAND, 4)
        sizer_7.Add((20, 20), 1, wx.ALL|wx.EXPAND, 4)
        sizer_3.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_3.Add(self.QueryGrid, 6, wx.ALL|wx.EXPAND, 4)
        self.SetSizer(sizer_3)
        self.Layout()
        self.Centre()
        # end wxGlade

    def RiempieGrid(self, rs, Titolo1):
        # dal recordset passato 'rs' ricava tutto ci che serve per riempire la grid
        # Recupera il numero delle colonne e le crea
        nFields = rs.Fields.Count
        self.QueryGrid.InsertCols(0,nFields)
        self.TitoloTabella.SetLabel(Titolo1)
        # Recupera i nomi dei campi e intesta le colonne
        n = 0
        for x in range(nFields):
            nome = rs.Fields.Item(x).Name
            len  = rs.Fields.Item(x).DefinedSize
            self.NomiCampi.append(nome)
            self.QueryGrid.SetColLabelValue(n, nome)
            if len > 20:
               if len < 100:   # allarga le colonne
                  self.QueryGrid.SetColSize(n, len * 4)
               else:
                  self.QueryGrid.SetColSize(n, 400)
            n += 1

        nRiga = 0
        # si scorre tutto il recordset e riempie la grid una riga alla volta
        #rs.MoveFirst()
        while not rs.EOF:
            self.QueryGrid.InsertRows(nRiga, 1)
            nCol = 0
            for n in range(nFields):
                v = rs.Fields.Item(n).Value
                if type(v).__name__ != 'string' and type(v).__name__ != 'unicode':
                   self.QueryGrid.SetCellValue(nRiga, nCol, str(v))
                else:
                   self.QueryGrid.SetCellValue(nRiga, nCol, v)
                nCol += 1
            nRiga += 1
            if nRiga >= 1000:
                wx.MessageBox("E' stato raggiunto il massimo di 1000 righe caricate", "Avviso")
                break
            rs.MoveNext()
        #rs.Close()

# end of class MyQuery


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.CAPTION|wx.CLOSE_BOX|wx.MINIMIZE_BOX|wx.MAXIMIZE_BOX|wx.SYSTEM_MENU|wx.RESIZE_BORDER|wx.TAB_TRAVERSAL|wx.CLIP_CHILDREN
        wx.Frame.__init__(self, *args, **kwds)
        self.frame_1_statusbar = self.CreateStatusBar(1, 0)
        self.label_1 = wx.StaticText(self, -1, "Trasforma il risultato di una Query SQL in un foglio Excel XML")
        self.label_2 = wx.StaticText(self, -1, "Database ODBC (DNS name):")
        self.txtDNS = wx.TextCtrl(self, 1001, "")
        self.label_3 = wx.StaticText(self, -1, "Username:")
        self.txtUser = wx.TextCtrl(self, 1002, "")
        self.label_4 = wx.StaticText(self, -1, "Password:")
        self.txtPassword = wx.TextCtrl(self, 1003, "", style=wx.TE_PASSWORD)
        self.Connetti = wx.Button(self, 1004, "Connetti")
        self.label_5 = wx.StaticText(self, -1, "Tabelle:  (doppio Click per generare la Select)")
        self.label_6 = wx.StaticText(self, -1, "Select SQL di estrazione dati:  (anche richiamo di StoredProcedure o copia-incolla)")
        self.ListaTabelle = wx.ListBox(self, 1005, choices=[], style=wx.LB_SINGLE|wx.LB_SORT)
        self.Query = wx.TextCtrl(self, 1006, "", style=wx.TE_PROCESS_ENTER|wx.TE_PROCESS_TAB|wx.TE_MULTILINE|wx.HSCROLL)
        self.Esporta = wx.Button(self, 1007, "Esporta")
        self.Vedi = wx.Button(self, 1008, "Vedi")
        self.Chiudi = wx.Button(self, 1009, "Chiudi")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.Connette, id=1004)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.GenSelect, id=1005)
        self.Bind(wx.EVT_BUTTON, self.EsportaExcel, id=1007)
        self.Bind(wx.EVT_BUTTON, self.EsegueSelect, id=1008)
        self.Bind(wx.EVT_BUTTON, self.ChiudiApp, id=1009)
        # end wxGlade
        # crea gli oggetti ADO Connessione e Recordset
        try:
           self.conn = win32com.client.Dispatch(r'ADODB.Connection')
           self.rs = win32com.client.Dispatch(r'ADODB.Recordset')
        except Exception, ex:
           wx.MessageBox(str(ex.args[1]) + "\n" + str(ex.args[2]), "Errore")
        self.NomiTabelle = []
        self.NomiCampi = []
        self.SQL = ""
        self.NomeTabella = ""


    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("Query2Excel")
        self.SetSize((800, 600))
        self.SetBackgroundColour(wx.Colour(208, 208, 208))
        self.frame_1_statusbar.SetStatusWidths([-1])
        # statusbar fields
        frame_1_statusbar_fields = [""]
        for i in range(len(frame_1_statusbar_fields)):
            self.frame_1_statusbar.SetStatusText(frame_1_statusbar_fields[i], i)
        self.label_1.SetBackgroundColour(wx.Colour(208, 208, 208))
        self.label_1.SetFont(wx.Font(12, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.txtDNS.SetMinSize((140, 24))
        self.txtDNS.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.txtDNS.SetToolTipString("Nome del driver ODBC")
        self.txtDNS.SetFocus()
        self.txtUser.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.txtUser.SetToolTipString("Utente di accesso al database")
        self.txtPassword.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.txtPassword.SetToolTipString("Password di accesso al database")
        self.Connetti.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.Connetti.SetToolTipString("Si connette al Database")
        self.label_5.SetMinSize((250, 13))
        self.ListaTabelle.SetMinSize((250, 420))
        self.Query.SetFont(wx.Font(12, wx.MODERN, wx.NORMAL, wx.NORMAL, 0, ""))
        self.Esporta.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.Esporta.SetToolTipString("Esegue la Query ed esporta il risultato in formato Excel")
        self.Vedi.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.Vedi.SetToolTipString("Mostra i dati risultanti della Select")
        self.Chiudi.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.Chiudi.SetToolTipString("Termina l'applicazione")
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.ALL, 4)
        sizer_2.Add(self.label_2, 0, wx.LEFT|wx.TOP|wx.BOTTOM, 10)
        sizer_2.Add(self.txtDNS, 0, wx.ALL, 4)
        sizer_2.Add(self.label_3, 0, wx.LEFT|wx.TOP|wx.BOTTOM, 10)
        sizer_2.Add(self.txtUser, 0, wx.ALL, 4)
        sizer_2.Add(self.label_4, 0, wx.LEFT|wx.TOP|wx.BOTTOM, 10)
        sizer_2.Add(self.txtPassword, 0, wx.ALL, 4)
        sizer_2.Add((80, 20), 1, wx.EXPAND|wx.ALIGN_RIGHT, 0)
        sizer_2.Add(self.Connetti, 0, wx.ALL, 6)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_6.Add(self.label_5, 0, wx.ALL|wx.ALIGN_BOTTOM, 4)
        sizer_6.Add(self.label_6, 0, wx.ALL|wx.ALIGN_BOTTOM, 4)
        sizer_1.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_4.Add(self.ListaTabelle, 0, wx.ALL|wx.EXPAND, 4)
        sizer_4.Add(self.Query, 2, wx.ALL|wx.EXPAND, 4)
        sizer_1.Add(sizer_4, 14, wx.EXPAND, 0)
        sizer_5.Add(self.Esporta, 0, wx.ALL, 4)
        sizer_5.Add((20, 20), 1, wx.EXPAND, 0)
        sizer_5.Add(self.Vedi, 0, wx.ALL, 4)
        sizer_5.Add((20, 20), 1, wx.EXPAND, 0)
        sizer_5.Add(self.Chiudi, 0, wx.ALL, 4)
        sizer_1.Add(sizer_5, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        self.Layout()
        self.Centre()
        # end wxGlade

    def Connette(self, event): # wxGlade: MyFrame.<event_handler>
        DSN = self.txtDNS.GetValue()
        User = self.txtUser.GetValue()
        Password = self.txtPassword.GetValue()
        if DSN.strip() == "":
            wx.MessageBox("Manca il nome Database", "Errore")
            return
        try:
            if self.conn.State != 0: self.conn.Close()
            if self.rs.State != 0: self.rs.Close()
            # Si conette al DB
            self.conn.Open(DSN, User, Password)
            # Recupera l'elenco delle Tabelle e Viste
            self.NomiTabelle = []
            adSchemaTables = 20
            rsTables = self.conn.OpenSchema(adSchemaTables)
            rsTables.Filter = "TABLE_TYPE = 'TABLE' Or TABLE_TYPE = 'VIEW'"
            # si scorre tutto il recordset e riempie la lista col nome delle tabelle
            while not rsTables.EOF:
               v = rsTables.Fields.Item(2).Value  # la terza colonna del recordset  il nome tabella o vista
               self.NomiTabelle.append(v)
               rsTables.MoveNext()
            self.ListaTabelle.Set(self.NomiTabelle)
            rsTables.Close()
            self.Query.SetValue("")
            self.NomeTabella = ""
        except Exception, ex:
            wx.MessageBox(str(ex.args[1]) + "\n" + str(ex.args[2]), "Errore")


    def ChiudiApp(self, event): # wxGlade: MyFrame.<event_handler>
        app.ExitMainLoop()

    def EsportaExcel(self, event): # wxGlade: MyFrame.<event_handler>
        self.SQL = self.Query.GetValue()
        if self.SQL == "" or self.conn.State == 0:
           wx.MessageBox("Database non connesso o testo della Query mancante", "Errore")
           return
        if self.NomeTabella != "":
           NomeFile = "Query" + self.NomeTabella
        else:
            NomeFile = "QueryExport"
        FileName = wx.FileSelector("Nome del file Excel da esportare:", ".", NomeFile, "xls", "*.xls")
        if FileName == "": return
        try:
            # esegue la select
            rs_SQL = self.Query.GetValue()
            self.rs.Open(rs_SQL, self.conn, 1, 3) # 1 e 3 sono constanti:  adOpenKeyset e adLockOptimistic

            wx.StockCursor(wx.CURSOR_WAIT)
            # inizializza Excel
            x1 = ExcelXML.xlsExcel(FileName)
            Sh = ExcelXML.xlsSheetStruct()
            Sh.Description = "Esportazione di: " + self.NomeTabella

            # aggiunge uno stile per l'intestazione campi
            st = ExcelXML.xlsStyleStruct()
            st.ID = "bold"
            st.FontBold  = True
            st.FontItalic  = True
            x1.xlsAddStyle(st)

            x1.xlsAddSheet("Query", Sh)
            # Recupera i nomi dei campi e allarga le colonne Excel
            self.NomiCampi = []
            nFields = self.rs.Fields.Count
            i = 0
            for x in range(nFields):
               len = self.rs.Fields.Item(x).DefinedSize
               self.NomiCampi.append(self.rs.Fields.Item(x).Name)
               if len > 80 : len = 80
               if len > 10: # allarga la colonna se necessario
                  x1.xlsColumn(i+1,(len*4))
               i += 1

            x1.xlsWriteCell("Esportazione di: " + self.NomeTabella)
            x1.xlsNewLine(1)
            # scrive l'intestazione dei campi
            x1.xlsWriteCell(self.NomiCampi,"S","bold")
            x1.xlsNewLine()

            count = 0
            # si scorre tutto il recordset
            #self.rs.MoveFirst()
            while not self.rs.EOF:
                for n in range(nFields):
                    v = self.rs.Fields.Item(n).Value
                    if type(v).__name__ == 'unicode':  #
                           v = v.encode('dbcs')        # evita problemi con caratteri strani
                    if type(v).__name__ == 'int' or type(v).__name__ == 'long' or type(v).__name__ == 'float':
                        x1.xlsWriteCell(v, "N")
                    else:
                        x1.xlsWriteCell(v)
                x1.xlsNewLine()

                count += 1
                self.rs.MoveNext()

            x1.xlsClose()
            self.rs.Close()
            wx.StockCursor(wx.CURSOR_ARROW )
            msg = "Sono state esportate " + str(count) + " righe nel foglio Excel '" + FileName + "'"
            self.frame_1_statusbar.SetStatusText(msg, 0)
            wx.MessageBox(msg, "Avviso")
        except Exception, ex:
            wx.MessageBox(str(ex.args[1]) + "\n" + str(ex.args[2]), "Errore")
            #wx.MessageBox(str(ex.args))


    def GenSelect(self, event): # wxGlade: MyFrame.<event_handler>
        selNumTab = self.ListaTabelle.GetSelections()
        self.NomeTabella = self.ListaTabelle.GetString(selNumTab[0])
        # Recupera l'elenco dei campi della tabella voluta dallo Schema del DB
        self.NomiCampi = []
        adSchemaColumns = 4
        rsColumns = self.conn.OpenSchema(adSchemaColumns)
        rsColumns.Filter = "TABLE_NAME = '" + self.NomeTabella + "'"
        # si scorre tutto il recordset filtrato e recupera il nome dei campi
        while not rsColumns.EOF:
            v = rsColumns.Fields.Item(3).Value  # la quarta colonna del recordset  il nome colonna
            self.NomiCampi.append(v)
            rsColumns.MoveNext()
        rsColumns.Close()
        selCampi = ""
        n = 0
        # elenca i campi nella Select
        for nC in self.NomiCampi:
           selCampi += " " + nC
           n += 1
           if n < len(self.NomiCampi): selCampi += ","
           if (n % 6) == 0 and n < len(self.NomiCampi): selCampi += "\n"   # a capo ogni 6 campi
        self.Query.SetValue("SELECT " + selCampi + "\nFROM " + self.NomeTabella)


    def EsegueSelect(self, event): # wxGlade: MyFrame.<event_handler>
        if self.Query.GetValue() == "" or self.conn.State == 0:
           wx.MessageBox("Database non connesso o testo della Query mancante", "Errore")
           return
        # esegue la select
        if self.rs.State != 0: self.rs.Close()
        try:
            rs_SQL = self.Query.GetValue()
            self.rs.Open(rs_SQL, self.conn, 1, 3) # 1 e 3 sono constanti:  adOpenKeyset e adLockOptimistic

            dialog_1 = MyQuery(self, -1, "")
            dialog_1.Show()
            dialog_1.RiempieGrid(self.rs, self.NomeTabella)
            dialog_1.Raise()
            self.rs.Close()
        except Exception, ex:
            wx.MessageBox(str(ex.args[1]) + "\n" + str(ex.args[2]), "Errore")

# end of class MyFrame


if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
